<?php

// Roundcube-style variables
$rcmail = rcmail::get_instance();

$USERNAME = $rcmail->config->get('USERNAME');
$HOME = $rcmail->config->get('HOME');
$RUNAS_CMD = $rcmail->config->get('RUNAS_CMD');
$MF = $rcmail->config->get('MF');

?>

<h2>Mail Forwarding</h2>

<?php

// Initialize variables
$oldForwardFileExist = FALSE;
$oldForwardFileConvert = FALSE;
$oldForwardFileResult = NULL;
$oldVacationMsg = NULL;
$oldForwardAddresses = NULL;
$oldFormatAddr_Arr = NULL;

$newForwardFileExist = FALSE;
$newForwardFileResult = NULL;
$newFormatVacation = NULL;
$newFormatAddr_Arr = NULL;

$newVacationFileResult = NULL;

$vacationExist = FALSE;
$localCopyChecked = NULL;
$localCopyPrior = 'off';
$hiddenInputStatic = '';
$hiddenInputTemp = '';
$result = NULL;
$type = NULL;

$newForwardCheckboxes = '';
$oldForwardCheckboxes = '';

$existingAddresses = FALSE;

$dynamicFormContent = '';

if (have_file('.forward', $result)) {
    $oldForwardFileExist = TRUE;
    $oldForwardFileResult = $result;
    $type = 'f';
}
elseif (have_file('.qmail', $result)) {
    $oldForwardFileExist = TRUE;
    $oldForwardFileResult = $result;
    $type = 'q';
}

// Do they have a mailfilter-vacation file?
if (have_file('Maildir/mailfilter-vacation', $result)) {
    $newVacationFileResult = $result;
    foreach ($newVacationFileResult as $line) {
        if (is_newFormatVacation($line, $_)) {
            $newFormatVacation_S = base64_encode(serialize($line));
            $hiddenInputStatic .= '<input type="hidden" name="newFormatVacation_S" id="newFormatVacation_S" value="' . $newFormatVacation_S . '" />';
            continue; 
        }
    }
    $hiddenInputTemp .= '<input type="hidden" name="newVacationFileExist" value="1" />';
}

//Do they have a mailfilter-forward file?
if (have_file('Maildir/mailfilter-forward', $result)) {
    $newForwardFileExist = TRUE;
    $newForwardFileResult = $result;
    foreach ($newForwardFileResult as $line) {
        if (is_newFormatLocalCopy($line)) {
            $localCopyChecked = '"checked"';
            $localCopyPrior = 'on';
        }
        if (is_newFormatAddress($line, $newFormatAddr_Arr)) {
            continue;
        }
        if (is_newFormatVacation($line, $_) && !isset($newFormatVacation_S)) {
            $newFormatVacation_S = base64_encode(serialize($line));
            $hiddenInputStatic .= '<input type="hidden" name="newFormatVacation_S" id="newFormatVacation_S" value="' . $newFormatVacation_S . '" />';
            continue;
        }
    } 
}

// Is the old forward file one we recognize (no weird procmail stuff, etc)
if ($oldForwardFileExist) {
    $oldForwardFileConvert = TRUE;
    $oldForwardMsg = '<strong>You currently have a mail forwarding file that is no longer being supported!</strong><br />';
    switch ($type) {
        case 'q':
            $firstLine = TRUE;
            foreach ($oldForwardFileResult as $line) {
                if ($firstLine) {
                    $firstLine = FALSE;
                    if (preg_match("/^\s*$/", $line)) {
                        $oldForwardFileConvert = FALSE;
                        break;
                    }
                }
                if (is_blankline($line) || is_comment($line)) {
                    continue;
                }
                if (is_oldFormatVacation($line)) {
                    $vacationExist = TRUE;
                    continue;
                }
                if (is_oldFormatLocalCopy($line)) {
                    $localCopyChecked = '"checked"';
                    $localCopyPrior = 'on';
                    continue;
                }
                // Found something bizarre
                if (!is_oldFormatAddress($line, $oldFormatAddr_Arr)) {
                    $oldForwardFileConvert = FALSE;
                    break;
                }
            }
            break;
        case 'f':
            foreach ($oldForwardFileResult as $line) {
                if (is_blankline($line) || is_comment_forward($line)) {
                    continue;
                }
                if (is_oldFormatVacation($line)) {
                    $vacationExist = TRUE;
                    continue;
                }
                if (is_oldFormatLocalCopy($line)) {
                    $localCopyChecked = '"checked"';
                    $localCopyPrior = 'on';
                    continue;
                }
                // Found something bizarre, let's let the user know
                if (!is_oldFormatAddress_forward($line, $oldFormatAddr_Arr)) {
                    $oldForwardFileConvert = FALSE;
                    break;
                }
            }
            break;
    }
}

// Save the old local copy preference
$hiddenInputTemp .= '<input type="hidden" id="localCopyPrior" name="localCopyPrior" value="'.$localCopyPrior.'" />';

// Are we converting?
if ($oldForwardFileConvert) {
    $oldForwardMsg .= '<strong>Submitting this form will convert the old format to the new supported format!</strong><br />';
    // Let the user know where their mail is stored, forwarded, and/or vacationed
    if ($vacationExist) {
        $oldForwardMsg .= 'You have vacation enabled, this will still exist, however if you would like to disable vacation check out the vacation webtool!<br />';
        $hiddenInputTemp .= '<input type="hidden" name="vacation" value="1" />';
    }
    if (is_array($oldFormatAddr_Arr)) {
        $oldForwardCheckboxes .= '<span class="checkbox-container">
                           <strong>Leave these addresses checked to continue forwarding to them:</strong>';
        foreach ($oldFormatAddr_Arr as $address) {
            $oldForwardCheckboxes .= 
                '<span class="checkbox-item">
                    <input type="checkbox" class="webtools-checkbox address-checkbox" id="checkbox_'.$address.'" name="oldFormatAddr_Arr['.$address.']" "checked" />
                    <label for="checkbox_'.$address.'" class="webtools-label">'.$address.'</label>
                 </span>';
        }
        $oldForwardCheckboxes .= '</span>';
        $existingAddresses = TRUE;
        
    }
    $hiddenInputTemp .= '<input type="hidden" name="forwardType" id="forwardType" value="'.$type.'" />';
}
else {
    if ($oldForwardFileExist) {
        $oldForwardMsg .= '<strong>However, we cannot convert the file to the new supported file format 
                           since it seems your file has some extra content we can\'t understand! Submitting 
                           the form below will add the new forwarding address to a a file in the new 
                           supported format!</strong>
                           <br />';
    }
}

// Fill in the form with values from the new forward file
if($newForwardFileExist){
    if (is_array($newFormatAddr_Arr)) {
        $newForwardCheckboxes .= '<span class="checkbox-container">
                                  <strong>Leave these addresses checked to continue forwarding to them:</strong>';
        foreach ($newFormatAddr_Arr as $address) {
            $newForwardCheckboxes .=
                '<span class="checkbox-item">
                    <input type="checkbox" class="webtools-checkbox address-checkbox" id="checkbox_'.$address.'" name="newFormatAddr_Arr['.$address.']" "checked" />
                    <label for="checkbox_'.$address.'" class="webtools-label">'.$address.'</label>
                    <a href="#" onclick="forward_post(false, \''.$address.'\'); return false;" title="Remove this address">
                        <img src="../../skins/rutgers/images/remove_address.png" style="height: 1.3em; width: 1.3em; position: relative; bottom: -5px;" />
                    </a>
                 </span>';
        }
        $newForwardCheckboxes .= '</span>'; 
        $existingAddresses = TRUE;
    }
}

if ($newForwardFileExist || $oldForwardFileExist) {

    $dynamicFormContent .= $oldForwardMsg . $oldForwardCheckboxes . $newForwardCheckboxes;
    if ($existingAddresses) {
        $dynamicFormContent .= '<a style="text-decoration: none;" href="#" onclick="forward_post(true); return false;" title="Remove all addresses">
                                    <img src="../../skins/rutgers/images/disable_forward.png" style="height: 1.5m; width: 1.5em; position: relative; bottom: -6px;" />
                                    Remove all
                                </a><br /><br />';
    }

}

// This is input that will not last after a post request
$dynamicFormContent .= $hiddenInputTemp;

?>

<script type="text/javascript" src="plugins/webtools/webtools/forward/forward_post.js"></script>

<div id="result" style="margin-bottom:10px;"></div>
<form id="webtools-form" onsubmit="return false;">
    <fieldset style="padding:30px 10px" class="ui-widget ui-widget-content ui-corner-all">
        <?=$hiddenInputStatic?>
        <span id="dynamic_content">
            <?=$dynamicFormContent?>
        </span>
        <label for="email" class="webtools-label" style="display:block;">Forward to</label>
        <input id="email" class="ui-corner-all-4px" type="text" name="newAddress" style="margin:5px auto; height:40px; font-size:30px;" value="" size="25" maxlength="129" />
        <span id="emailError" style="display:block; font-style:italic; color:#DC5757;"></span>
        <br />
        <input id="localCopy" type="checkbox" class="webtools-checkbox" name="localCopy" <?=$localCopyChecked?> />
        <label for="localCopy" class="webtools-label">Copy to my local account</label>
        </span>
        <button class="webtools-button ui-state-default ui-corner-all" style="display:block; margin-top:30px;" onclick="return forward_post();">Submit</button>
    </fieldset>
</form>
